﻿Imports System.Reflection
Imports Syncfusion.UI.Xaml.Charts

Class MainWindow

    Dim TestColl As New ViewModel
    Dim LineSeries As New FastStepLineBitmapSeries

    Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.


        ' ADD SERIES
        With LineSeries
            .ItemsSource = TestColl.Tickers(0).Minutes
            .XBindingPath = "DateTime"
            .YBindingPath = "Close"
            .Interior = New SolidColorBrush(Color.FromArgb(255, 100, 120, 255))
            .StrokeThickness = 1
        End With
        chart.Series.Add(LineSeries)

        'ADD ANNOTATIONS
        Dim newEllipseAnnotation As New EllipseAnnotation
        With newEllipseAnnotation
            .X1 = 1000
            .Y1 = TestColl.Tickers(0).Minutes(1000).Close
            .Width = 8
            .Height = 8
            .StrokeThickness = 1
            .Stroke = New SolidColorBrush(Colors.Black)
            .Foreground = New SolidColorBrush(Colors.White)
            .Fill = New SolidColorBrush(Colors.Red)
            .CoordinateUnit = CoordinateUnit.Axis
            .HorizontalAlignment = HorizontalAlignment.Center
            .VerticalAlignment = VerticalAlignment.Center

            .ShowToolTip = True
            .ToolTipContent = "This is an annotation tooltip test."
            .ToolTipShowDuration = 5000
        End With
        chart.Annotations.Add(newEllipseAnnotation)


        'SET NO ANTIALIAS
        Dim image As Image = GetPrivateField(chart, "fastRenderDevice")
        If (Not (image) Is Nothing) Then
            RenderOptions.SetBitmapScalingMode(image, BitmapScalingMode.NearestNeighbor)
        End If

    End Sub

    Private Function GetPrivateField(ByVal chart As SfChart, ByVal name As String) As Image
        Dim info As FieldInfo = chart.GetType().GetField(name, BindingFlags.Instance Or (BindingFlags.NonPublic Or BindingFlags.Public))
        If (Not (info) Is Nothing) Then
            Return CType(info.GetValue(chart), Image)
        End If
        Return Nothing
    End Function
End Class
