﻿Imports System.Collections.ObjectModel

Public Class ViewModel

    Public Property Tickers As New ObservableCollection(Of ticker)
    Public RandomGenerator As New Random
    Dim dayMinutes = 440


    Sub New()

        Tickers.Add(New Ticker With {.TotalDays = 10, .Name = "A"})
        Tickers.Add(New Ticker With {.TotalDays = 100, .Name = "B"})
        Tickers.Add(New Ticker With {.TotalDays = 100, .Name = "C"})
        Tickers.Add(New Ticker With {.TotalDays = 100, .Name = "D"})

        addPoints1(0) 'A
        addPoints1(1) 'B

        addPoints1(3) 'D

    End Sub

    Sub addPoints1(inIndex As Integer)
        Dim price As Double = 100
        Dim startDay As DateTime = DateTime.Parse("01/01/2000 00:00 AM")
        Dim countDays As Integer = 0

        Do

            If startDay.DayOfWeek <> DayOfWeek.Saturday And startDay.DayOfWeek <> DayOfWeek.Sunday Then

                Dim DateTimeMinute As DateTime = startDay.AddHours(9)
                price = 100

                For j = 0 To dayMinutes - 1 'for each minute

                    Dim ChangeDirection As Integer = GetRandomInteger(0, 1)
                    Dim Change As Double = GetRandomDouble(5)
                    Select Case ChangeDirection
                        Case 0
                            Change = Change
                        Case 1
                            Change = -Change
                    End Select

                    price = price * ((Change / 100) + 1)

                    Dim newMinute As New Minute
                    newMinute.DateTime = DateTimeMinute
                    newMinute.Open = price
                    newMinute.High = price
                    newMinute.Low = price
                    newMinute.Close = price

                    Tickers(inIndex).Minutes.Add(newMinute)

                    DateTimeMinute = DateTimeMinute.AddMinutes(1)

                Next

                countDays += 1

            End If

            startDay = startDay.AddDays(1)

        Loop Until countDays >= Tickers(inIndex).TotalDays

    End Sub


    Public Function GetRandomInteger(ByVal Min As Integer, ByVal Max As Integer) As Integer
        Return RandomGenerator.Next(Min, Max + 1)
    End Function

    Public Function GetRandomDouble(ByVal Max As Integer) As Double
        Return RandomGenerator.NextDouble() * Max
    End Function


End Class
